function [rq3,rq12,rq24] = ekf_chv_base_sim(x)
%(2) initial values for Xi : 12 numbers
global Y;global T;global xi0;

 f1=1;f2=1;f3=1;f4=1;f5=1;
 nn=4; nr=5; nt=48;qnt=192;
 
%(3) variance for v: 6 numbers for q
% for sector: the loewr bound is 0.00001

  q1=x(1)^2;
  q2=x(2)^2;
  q3=x(3)^2; 
  q4=x(4)^2;

d11= x(5); %duration 2-3 m
d12= x(6); %duration 4-6 m
d13= x(7); %duration 7-12 m

 R(1,1)=x(8)^2;
 R(2,2)=x(9)^2;
 R(3,3)=x(10)^2;
 R(4,4)=x(11)^2;
 R(5,5)=x(12)^2;

ff = [f1,0,0,0;...
      0,f2,0,0;...
      0,0,f3,0;...
      0,0,0,f4];
  
ff=eye(4);
F=zeros(4*nt,4*nt);

F(1:4,1:4)=ff;

for q=1:nt-1
F(1+4*q:4+4*q,1+4*(q-1):4+4*(q-1))=eye(4);
end

qq = [q1,0,0,0;...
      0,q2,0,0;...
      0,0,q3,0;...
      0,0,0,q4];

Q=zeros(4*nt,4*nt);
Q(1:4,1:4)=qq;

c=10;
sigma2 = 0.1;
I4 = c*eye(4,4);
S = zeros(192,192,48);
S(1:192,1:192,1)=kron(ones(48,48),I4);
for j=2:48
    S(4*(j-1)+1:192,4*(j-1)+1:192,j)=kron(ones(48-(j-1),48-(j-1)),(sigma2)*eye(4,4));
end

P0(:,:,1)=sum(S,3);

ll=ones(T,1);
PP=ones(T,2);
W=ones(T,2);

%% 2. forecast for y(yhat), xi(t|t-1), P1, P0,

JH1 = zeros(nr,4*nt,T);
JH = zeros(4*nt,nr,T);
VY = zeros(nr,nr,T);
yhat = zeros(nr,T);
xi1 = zeros(4*nt,T);
P1 = zeros(4*nt,4*nt,T);

%% matrix of derivatives %%

D = zeros(nt,1); % matrix of duration dependence parameter

D(1,1)=0;

D(2,1)=d11*(1/48) + d12*[2*(1/48)^2-1] + d13*[4*(1/48)^3-3*(1/48)];
D(3,1)=d11*(2/48) + d12*[2*(2/48)^2-1] + d13*[4*(2/48)^3-3*(2/48)];
D(4,1)=d11*(3/48) + d12*[2*(3/48)^2-1] + d13*[4*(3/48)^3-3*(3/48)];
D(5,1)=d11*(4/48) + d12*[2*(4/48)^2-1] + d13*[4*(4/48)^3-3*(4/48)];
D(6,1)=d11*(5/48) + d12*[2*(5/48)^2-1] + d13*[4*(5/48)^3-3*(5/48)];
D(7,1)=d11*(6/48) + d12*[2*(6/48)^2-1] + d13*[4*(6/48)^3-3*(6/48)];
D(8,1)=d11*(7/48) + d12*[2*(7/48)^2-1] + d13*[4*(7/48)^3-3*(7/48)];
D(9,1)=d11*(8/48) + d12*[2*(8/48)^2-1] + d13*[4*(8/48)^3-3*(8/48)];
D(10,1)=d11*(9/48) + d12*[2*(9/48)^2-1] + d13*[4*(9/48)^3-3*(9/48)];
D(11,1)=d11*(10/48) + d12*[2*(10/48)^2-1] + d13*[4*(10/48)^3-3*(10/48)];

for i=12:nt
D(i,1)=d11*((i-2)/48) + d12*[2*((i-2)/48)^2-1] + d13*[4*((i-2)/48)^3-3*((i-2)/48)];
end %duration 13+ m

tau = zeros(nt,nt);

 for i=1:nt
 for j=2:nt
     k=i-j+1;
     if k>0
     tau(i,j-1)=k;
     else 
     tau(i,j-1)=0;
     end
 end
 end

 MW1(:,:,:) = ones(nt,nt,T);
 MW2(:,:,:) = ones(nt,nt,T);
 MC1(:,:,:) = zeros(nt,nt,T);
 MC2(:,:,:) = zeros(nt,nt,T);
 MP1(:,:,:) = zeros(nt,nt,T);
 MP2(:,:,:) = zeros(nt,nt,T);
 D_MW1(:,:,:)=zeros(nt,nt,T);
 D_MW2(:,:,:)=zeros(nt,nt,T);
 D_MP1(:,:,:)=zeros(nt,nt,T);
 D_MP2(:,:,:)=zeros(nt,nt,T);
 M_JH1 = zeros(nt,qnt,T);

for t=1:T

 for i=1:nt
 W1(i,t) = xi0(1+4*(i-1),t);
 W2(i,t) = xi0(2+4*(i-1),t);
 X1(i,t) = xi0(3+4*(i-1),t);
 X2(i,t) = xi0(4+4*(i-1),t);
 end

 for i=2:nt
 for j=1:nt            
     if tau(i,j)>0
 MW1(i,j,t) = exp(-exp(X1(j,t)+D(tau(i,j),1)));
 MW2(i,j,t) = exp(-exp(X2(j,t)+D(tau(i,j),1)));
     else
 MW1(i,j,t) = 1;
 MW2(i,j,t) = 1;
 end
 end
 end

 D_MW1(1,1,t)= 1;
 D_MW2(1,1,t)= 1;
 
for j=1:nt
 D_MW1(j,j,t)= prod(MW1(j,:,t),2);
 D_MW2(j,j,t)= prod(MW2(j,:,t),2);
end

 MP1(1,:,t)=zeros(1,nt);
 MP2(1,:,t)=zeros(1,nt);

 for i=2:nt
 MP1(i,1:i-1,t)=W1(i,t)*D_MW1(i,i,t);
 MP2(i,1:i-1,t)=W2(i,t)*D_MW2(i,i,t);
 end

 MC1(1,:,t)=zeros(1,nt);
 MC2(1,:,t)=zeros(1,nt);

 for i=2:nt
 for j=1:nt 
     if tau(i,j)>0
 MC1(i,j,t) = -exp(X1(j,t)+D(tau(i,j),1));
 MC2(i,j,t) = -exp(X2(j,t)+D(tau(i,j),1));
     else
 MC1(i,j,t) = 0;
 MC2(i,j,t) = 0;
 end
 end
 end
 
 for i=1:nt
 for j=1:nt 
 D_MP1(i,j,t)= MP1(i,j,t).*MC1(i,j,t);
 D_MP2(i,j,t)= MP2(i,j,t).*MC2(i,j,t);
 end
 end

for i=1:nt
M_JH1(:,1+4*(i-1),t)=D_MW1(:,i,t);
M_JH1(:,2+4*(i-1),t)=D_MW2(:,i,t);
M_JH1(:,3+4*(i-1),t)=D_MP1(:,i,t);
M_JH1(:,4+4*(i-1),t)=D_MP2(:,i,t);
end

 UL(1,t)=W1(1,t)*D_MW1(1,1,t);
 UH(1,t)=W2(1,t)*D_MW2(1,1,t);
 TU(1,t)=UL(1,t)+UH(1,t);

for k=2:nt
 UL(k,t)=W1(k,t)*D_MW1(k,k,t);
 UH(k,t)=W2(k,t)*D_MW2(k,k,t);
 TU(k,t)=UL(k,t)+UH(k,t);
end

yhat(1,t)=TU(1,t);
yhat(2,t)=TU(2,t)+TU(3,t);
yhat(3,t)=TU(4,t)+TU(5,t)+TU(6,t);
yhat(4,t)=sum(TU(7:12,t),1);
yhat(5,t)=sum(TU(13:nt,t),1);

JH1(1,:,t)= M_JH1(1,:,t);
JH1(2,:,t)= M_JH1(2,:,t)+M_JH1(3,:,t);
JH1(3,:,t)= M_JH1(4,:,t)+M_JH1(5,:,t)+M_JH1(6,:,t);
JH1(4,:,t)= sum(M_JH1(7:12,:,t),1);
JH1(5,:,t)= sum(M_JH1(13:nt,:,t),1);

JH(:,:,t)=JH1(:,:,t)';

%(3)Variance of Y: E[(Y-EY)(Y-EY)'] 

VY(:,:,t)=(JH(:,:,t)')*P0(:,:,t)*(JH(:,:,t))+R; %+ 0.1*eye(5,5); % Variance of Y

%(4)\xi(t|t)
xi1(:,t)=xi0(:,t)+P0(:,:,t)*JH(:,:,t)/(VY(:,:,t))*(Y(t,:)'-yhat(:,t));
 
%(5)P(t|t)

P1(:,:,t) = P0(:,:,t)-P0(:,:,t)*JH(:,:,t)/(VY(:,:,t))*JH(:,:,t)'*P0(:,:,t);

% 3. Forecast of \xi
xi0(:,t+1) = F*xi1(:,t);

%(2) P0(t+1|t)
P0(:,:,t+1) =  F*P1(:,:,t)*F' + Q;

W(t,1)=xi0(1,t);
W(t,2)=xi0(2,t);
PP(t,1) = exp(-exp(xi0(3,t)));
PP(t,2) = exp(-exp(xi0(4,t)));
end

J = zeros(192,192,T);
for i=1:T
    J(:,:,i) = P1(:,:,i)*F'*inv(P0(:,:,i+1));
end

% smoothed series %
    sxi(:,T) = xi1(:,T);
    sxi(:,T-1) = xi1(:,T)+J(:,:,T-1)*(sxi(:,T)-xi0(:,T));
    
for i=2:T-1
    sxi(:,T-i) = xi1(:,T-i)+J(:,:,T-i)*(sxi(:,T+1-i)-xi0(:,T+1-i));
end

% corresponding mean squared errors %
 SP(:,:,T) = P1(:,:,T);
 SP(:,:,T-1) = P0(:,:,T-1) + J(:,:,T-1)*(P1(:,:,T)-P0(:,:,T))*J(:,:,T-1)';
for i=2:T-1
    SP(:,:,T-i) = P1(:,:,T-i)+J(:,:,T-i)*(SP(:,:,T+1-i)-P0(:,:,T+1-i))*J(:,:,T-i)';
end

% var_decomposition %

nt=48;
qnt=48*4;

Q1 = zeros(qnt,qnt);
Q1(1,1)=q1;
Q2 = zeros(qnt,qnt);
Q2(2,2)=q2;
Q3 = zeros(qnt,qnt);
Q3(3,3)=q3;
Q4 = zeros(qnt,qnt);
Q4(4,4)=q4;

for nn=1:nt
    tmp = 4*(nn-1);
    ssxi(tmp+1,nn:nn+T-1) = sxi(1,:);
    ssxi(tmp+2,nn:nn+T-1) = sxi(2,:);
    ssxi(tmp+3,nn:nn+T-1) = sxi(3,:);
    ssxi(tmp+4,nn:nn+T-1) = sxi(4,:);
end

 dssxi = ssxi(:,nt:T);
 dsxi = sxi(:,nt:T);
 dxi = xi0(:,nt:T);
 TT = T-nt+1;
 nn = 49;
 Xi=dssxi;

vVY_total=zeros(nn,TT);
vVY_1=zeros(nn,TT);
vVY_2=zeros(nn,TT);
vVY_3=zeros(nn,TT);
vVY_2_q1=zeros(nn,TT);
vVY_2_q2=zeros(nn,TT);
vVY_2_q3=zeros(nn,TT);
vVY_2_q4=zeros(nn,TT);

fxi0 = zeros(192,410);

mat_n = [3;12;24];

for xx=1:3
n = mat_n(xx,1);

W1 = zeros(nt,TT);
W2 = zeros(nt,TT);
X1 = zeros(nt,TT);
X2 = zeros(nt,TT);

MW1 = ones(nt,nt,TT);
MW2 = ones(nt,nt,TT);
MC1 = zeros(nt,nt,TT);
MC2 = zeros(nt,nt,TT);
MP1 = zeros(nt,nt,TT);
MP2 = zeros(nt,nt,TT);
D_MW1 = zeros(nt,nt,TT);
D_MW2 = zeros(nt,nt,TT);
D_MP1 = zeros(nt,nt,TT);
D_MP2 = zeros(nt,nt,TT);
M_JH1 = zeros(nt,qnt,TT);

UL=zeros(nt,TT);
UH=zeros(nt,TT);
TU=zeros(nt,TT);

yhat = zeros(5,TT);
fJH1 = zeros(5,qnt,TT);
fJH = zeros(qnt,5,TT);

Xq=zeros(qnt,qnt,n-1);
Xq1=zeros(qnt,qnt,n-1);
Xq2=zeros(qnt,qnt,n-1);
Xq3=zeros(qnt,qnt,n-1);
Xq4=zeros(qnt,qnt,n-1);

SXq=zeros(qnt,qnt);
SXq1=zeros(qnt,qnt);
SXq2=zeros(qnt,qnt);
SXq3=zeros(qnt,qnt);
SXq4=zeros(qnt,qnt);

fVY_total=zeros(5,5,TT);
fVY_1=zeros(5,5,TT);
fVY_2=zeros(5,5,TT);
fVY_2_q1=zeros(5,5,TT);
fVY_2_q2=zeros(5,5,TT);
fVY_2_q3=zeros(5,5,TT);
fVY_2_q4=zeros(5,5,TT);
fVY_3=zeros(5,5,TT);

fxi0(:,n+1) = (F^n)*Xi(:,1);

for t=n+1:TT 

 for i=1:nt
 W1(i,t) = fxi0(1+4*(i-1),t);
 W2(i,t) = fxi0(2+4*(i-1),t);
 X1(i,t) = fxi0(3+4*(i-1),t);
 X2(i,t) = fxi0(4+4*(i-1),t);
 end

 for i=2:nt 
 for j=1:nt            
     if tau(i,j)>0
 MW1(i,j,t) = exp(-exp(X1(j,t)+D(tau(i,j),1)));
 MW2(i,j,t) = exp(-exp(X2(j,t)+D(tau(i,j),1)));
     else
 MW1(i,j,t) = 1;
 MW2(i,j,t) = 1;
 end
 end
 end

 D_MW1(1,1,t)= 1;
 D_MW2(1,1,t)= 1;
 
 for j=1:nt
 D_MW1(j,j,t)= prod(MW1(j,:,t),2);
 D_MW2(j,j,t)= prod(MW2(j,:,t),2);
 end

 MP1(1,:,t)=zeros(1,nt);
 MP2(1,:,t)=zeros(1,nt);

 for i=2:nt
 MP1(i,1:i-1,t)=W1(i,t)*D_MW1(i,i,t);
 MP2(i,1:i-1,t)=W2(i,t)*D_MW2(i,i,t);
 end

 MC1(1,:,t)=zeros(1,nt);
 MC2(1,:,t)=zeros(1,nt);

 for i=2:nt
 for j=1:nt 
     if tau(i,j)>0
 MC1(i,j,t) = -exp(X1(j,t)+D(tau(i,j),1));
 MC2(i,j,t) = -exp(X2(j,t)+D(tau(i,j),1));
     else
 MC1(i,j,t) = 0;
 MC2(i,j,t) = 0;
 end
 end
 end
 
 for i=1:nt
 for j=1:nt 
 D_MP1(i,j,t)= MP1(i,j,t).*MC1(i,j,t);
 D_MP2(i,j,t)= MP2(i,j,t).*MC2(i,j,t);
 end
 end

for i=1:nt
M_JH1(:,1+4*(i-1),t)=D_MW1(:,i,t);
M_JH1(:,2+4*(i-1),t)=D_MW2(:,i,t);
M_JH1(:,3+4*(i-1),t)=D_MP1(:,i,t);
M_JH1(:,4+4*(i-1),t)=D_MP2(:,i,t);
end

fJH1(1,:,t)= M_JH1(1,:,t);
fJH1(2,:,t)= M_JH1(2,:,t)+M_JH1(3,:,t);
fJH1(3,:,t)= M_JH1(4,:,t)+M_JH1(5,:,t)+M_JH1(6,:,t);
fJH1(4,:,t)= sum(M_JH1(7:12,:,t),1);
fJH1(5,:,t)= sum(M_JH1(13:48,:,t),1);

FJH1(t,:) = ones(1,5)*fJH1(:,:,t);
FJH(:,:,t) = reshape(FJH1(t,:)',4,nt);

if n<nt
FJH(:,n+1:nt,t) = zeros(4,nt-n);
CFJH(:,1:n,t)=cumsum(FJH(:,1:n,t),2);
sq_CFJH(:,1:n,t)=CFJH(:,1:n,t).*CFJH(:,1:n,t);
csum_CFJH(:,t,n)=sum(sq_CFJH(:,1:n,t),2);
else
CFJH(:,1:nt,t)=cumsum(FJH(:,1:nt,t),2);
sq_CFJH(:,1:nt,t)=CFJH(:,1:nt,t).*CFJH(:,1:nt,t);
csum_CFJH(:,t,n)=sum(sq_CFJH(:,1:nt,t),2);
end

vq=[q1,q2,q3,q4];
vVY_2(t,n)= vq*csum_CFJH(:,t,n);
vVY_2_q1(t,n)= vq(1,1)*csum_CFJH(1,t,n);
vVY_2_q2(t,n)= vq(1,2)*csum_CFJH(2,t,n);
vVY_2_q3(t,n)= vq(1,3)*csum_CFJH(3,t,n);
vVY_2_q4(t,n)= vq(1,4)*csum_CFJH(4,t,n);

fxi0(:,t+1) = (F^n)*Xi(:,t+1-n);

end
sum_TU(n,:) = sum(TU,1);
sum_vVY_q(n,1) = sum(vVY_2(:,n),1)/(TT-n);
sum_vVY_q(n,2) = sum(vVY_2_q1(:,n),1)/(TT-n);
sum_vVY_q(n,3) = sum(vVY_2_q2(:,n),1)/(TT-n);
sum_vVY_q(n,4) = sum(vVY_2_q3(:,n),1)/(TT-n);
sum_vVY_q(n,5) = sum(vVY_2_q4(:,n),1)/(TT-n);

ratio_q(n,1) = sum_vVY_q(n,2)/sum_vVY_q(n,1);
ratio_q(n,2) = sum_vVY_q(n,3)/sum_vVY_q(n,1);
ratio_q(n,3) = sum_vVY_q(n,4)/sum_vVY_q(n,1);
ratio_q(n,4) = sum_vVY_q(n,5)/sum_vVY_q(n,1);

end

rq3 = ratio_q(3,:);
rq12 = ratio_q(12,:);
rq24 = ratio_q(24,:);

end